
%% [MATLAB GUI] Initial code 
function varargout = direc16(varargin)
% DIREC16 MATLAB code for direc16.fig
%      DIREC16, by itself, creates a new DIREC16 or raises the existing
%      singleton*.
%
%      H = DIREC16 returns the handle to a new DIREC16 or the handle to
%      the existing singleton*.
%
%      DIREC16('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DIREC16.M with the given input arguments.
%
%      DIREC16('Property','Value',...) creates a new DIREC16 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before direc16_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to direc16_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Move the above text to modify the response to help direc16

% Last Modified by GUIDE v2.5 25-Feb-2021 18:15:47

% Begin initialization code - DO NOT MOVE
% version 1.2  "Export pdf" added 21/2/25

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @direc16_OpeningFcn, ...
                   'gui_OutputFcn',  @direc16_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT MOVE


% --- Executes just before direc16 is made visible.
function direc16_OpeningFcn(hObject, eventdata, handles, varargin)

% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to direc16 (see VARARGIN)

% Initialize Axes

axes(handles.axes3),
   xlimit = get(gca,'xlim');
   ylimit = get(gca,'ylim');
   text((xlimit(2)+xlimit(1))./2,(ylimit(2)+ylimit(1))./2,...
       {'\fontsize{14}Equal Area Plot'},...
       'HorizontalAlignment','center','BackgroundColor','w');
   set(gca,'XMinorTick','on');
   set(gca,'YMinorTick','on');
   set(gca,'XTickLabel','');  
   set(gca,'YTickLabel',''); 
   set(gca,'Ticklength',[0.015;0.04]);
   box on;

% Prepare Open Recent Menu   
fullfnames = getMRU();
handles.ffnames = fullfnames;

hMruMenu = findall(gcf, 'tag', 'OpenRecent');
for fileIdx = 1:length(fullfnames) 
   [pathstr,fname,ext] = fileparts(char(fullfnames{fileIdx}));
   handles.hMRUcld(fileIdx) = uimenu(hMruMenu,'Label',[fname ext],...
       'Callback',{@pushbutton1_Callback, handles, fullfnames{fileIdx}});
end

% Choose default command line output for direc16
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes direc16 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = direc16_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function fnames = getMRU()

if ispc
    home = [getenv('HOMEDRIVE') getenv('HOMEPATH')];
    pmagplotdir = [home '\Library\Preferences\PmagPlot'];
    direc16preffile = [pmagplotdir '\direc16.prf'];
else
    home = getenv('HOME');
    pmagplotdir = [home '/Library/Preferences/PmagPlot'];
    direc16preffile = [pmagplotdir '/direc16.prf'];
end

% pmagplotdir = [home '/Library/Preferences/PmagPlot'];
% direc16preffile = [pmagplotdir '/direc16.prf'];

fid = fopen(direc16preffile, 'r'); 
if (fid >= 0)
    prfline = textscan(fid,'%s');
    fclose(fid);
    cprfline = char(prfline{1}); 
    fnames = {};
    for ii = 1:size(cprfline,1)
        fnametop = strfind(cprfline(ii,:), 'DataMRU');
        if fnametop == 1;
           fnames = [fnames; cellstr(cprfline(ii,fnametop+10:end))];  
        end
    end
else
    fnames = []; 
end  


function [hObject, eventdata, handles] = setMRU(hObject, eventdata, handles)

if ispc
    home = [getenv('HOMEDRIVE') getenv('HOMEPATH')];
    myprefdir = [home '\Library\Preferences'];
    pmagplotdir = [home '\Library\Preferences\PmagPlot'];
else
    home = getenv('HOME');
    myprefdir = [home '/Library/Preferences'];
    pmagplotdir = [home '/Library/Preferences/PmagPlot'];
end

if exist(pmagplotdir) == 0
   mkdir(myprefdir,'PmagPlot');
end

if ispc
    direc16preffile = [pmagplotdir '\direc16.prf'];
else
    direc16preffile = [pmagplotdir '/direc16.prf'];
end    

openfname = [handles.PathName handles.FileName];
fullfnames = getMRU();
handles.ffnames = fullfnames;
exiflag = 0;
for ii = 1:length(handles.ffnames)
    if strcmp(handles.ffnames{ii}, openfname)
       exiflag = 1;
       oldii = ii;
    end
end

if exiflag
   handles.ffnames(oldii)=[];
end

fidd = fopen(openfname);
if (fidd >= 0)
  handles.ffnames = cellstr([openfname; handles.ffnames]);
  fclose(fidd);
end

fid = fopen(direc16preffile, 'w');
listleng = min(length(handles.ffnames), 9);
for ii = 1:listleng
   fprintf(fid, '%7s%1d%2s%s\n',...
          'DataMRU',listleng-ii+1,'=S', handles.ffnames{ii});
end
fclose(fid);


% open recent list update
fullfnames = handles.ffnames;
hMruMenu2 = findall(gcf, 'tag', 'OpenRecent');
hAllMenuItems = allchild(hMruMenu2);
delete(hAllMenuItems);

for fileIdx = 1:length(fullfnames) 
   [pathstr,fname,ext] = fileparts(char(fullfnames{fileIdx}));
   uimenu(hMruMenu2,'Label',[fname ext],...
       'Callback',{@pushbutton1_Callback, handles, fullfnames{fileIdx}});
end


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles, recentfile)
 
if nargin < 4 
    try, cd(handles.PathName), end
       [handles.FileName, handles.PathName] =...
           uigetfile({'*.txt',  'datafiles (*.txt)'; ...
             '*.*',  'All Files (*.*)'}, ... 
                'Pick a tspin data file (*.txt)');
        if (handles.FileName==0) return 
        end
else
    [pathstr,fname,ext] = fileparts(recentfile);
    if ispc
        handles.PathName = [pathstr '\'];
    else
        handles.PathName = [pathstr '/'];
    end    
    handles.FileName = [fname ext];
end

    jj = strfind(handles.FileName, '.');
    handles.fnamecore = handles.FileName(1:jj-1);

if ~isequal(handles.FileName,0),
    A(:,:) = zeros(0);     did = [];   spcstr = [];
    fidd = fopen([handles.PathName handles.FileName]);
    if (fidd < 0)
      [hObject, eventdata, handles] = setMRU(hObject, eventdata, handles);
      msgbox(['''', handles.FileName, ''' is NOT found.'],...
                'datafile loading error','error');  
      return
    else
      ii = 1;
      %tline = fgetl(fidd);   % first line ignored
      while ~feof(fidd)
        tline = fgetl(fidd); 
        if ~(isempty(strtrim(tline)) || strncmp(strtrim(tline), '!', 1))
          did = [did; cellstr(strtrim(tline))];
          tline = fgetl(fidd);
          while ~(isempty(strtrim(tline)) || strncmp(strtrim(tline), '!', 1))
            remain = strtrim(tline);
            ttline = [];
            for k=1:5
               [str, remain] = strtok(remain);
               ttline = [ttline ' ' str];
               if isempty(str),  break;  end
            end
            Aline = textscan(ttline, '%s %f %f %s %f');
            indexAline = [ii Aline{1,:}];
            if (size(A,1) ~= 0 && size(A,2) ~= size(indexAline,2)) 
                 break; end
            A = [A; indexAline];
            if feof(fidd), break; end
            tline = fgetl(fidd);
          end
          ii = ii+1;
          if (size(A,1) ~= 0 && size(A,2) ~= size(indexAline,2)) 
%              msgbox(['''', handles.FileName, ''' is NOT loaded.'], 'datafile loading error','error') ;
             break; 
          end
         end
      end
      fclose(fidd);
    end
    
    set(handles.CopyFigure,'Enable','on');
    set(handles.SavePlot,'Enable','on');
    set(handles.Move,'Enable','on');
    set(handles.Site,'Enable','on');

    if size(A,2) >= 4
        set(handles.figure1, 'Name', handles.FileName);  

        handles.SiteName     = char(did);
        handles.SiteIndex    = cell2mat(A(:,1));
        handles.UniqueSite   = unique(handles.SiteIndex);
        handles.SampleName   = A(:,2);
        handles.decl         = cell2mat(A(:,3));
        handles.incl         = cell2mat(A(:,4));

        duma95(1:size(A,1)) = 1.0;  % dummy a95
        if size(A,2) <= 4
            handles.a95          = duma95';
        else
            if isempty(strfind(char(A(1,5)),'e')) && isempty(strfind(char(A(1,5)),'E'))
              handles.a95 =  str2num(char(A(:,5)));
           elseif size(A,2) == 5
              handles.Intensity    = str2num(char(A(:,5)));
              handles.a95          = duma95';
            else
              handles.Intensity    = str2num(char(A(:,5)));
    %           handles.Intensity    = str2num(cell2mat(A(:,5)));
              handles.a95          = cell2mat(A(:,6));
            end
        end

        handles.North         = cosd(handles.incl).*cosd(handles.decl);
        handles.East          = cosd(handles.incl).*sind(handles.decl);
        handles.Vertical      = sind(handles.incl);

        handles.SiteIndexNow = 1;

        % jumpto list    
        hMoveMenu = findall(gcf, 'tag', 'Move');
        hJutMenu  = findall(gcf, 'tag', 'Jumpto');
        delete(hJutMenu);
        hJutMenu = uimenu('Label','Jump to', 'tag', 'Jumpto', 'Separator', 'on', 'Parent', hMoveMenu);

        for ii = 1:length(handles.UniqueSite) 
           uimenu(hJutMenu,'Label',num2str(handles.SiteName(ii, :)),...
               'tag', num2str(ii),...
               'Callback',{@pushbutton4_Callback, handles, ii});
        end

        handles.SiteIndexPre = handles.SiteIndexNow;
        set(handles.Drawa95, 'Checked','off'); 
        set(handles.Plotmean,'Checked','off');

        [hObject, eventdata, handles] = Update_SiteRelated(hObject, eventdata, handles);

        guidata(hObject,handles);

        [hObject, eventdata, handles] = setMRU(hObject, eventdata, handles);
     
    else
        msgbox(['''', handles.FileName, ''' is NOT loaded.'], 'datafile loading error','error') ;
    end    
   
else 
    msgbox('Operation cancelled by user, no data file loaded.', 'data file loading confirmation','warn') ;  

end


%% [Push] Top Site
function pushbutton7_Callback(hObject, eventdata, handles)

handles.SiteIndexPre = handles.SiteIndexNow;
handles.SiteIndexNow = 1;
[hObject, eventdata, handles] = Update_SiteRelated(hObject, eventdata, handles);

guidata(hObject,handles);

%% [Push] Next Site
function pushbutton2_Callback(hObject, eventdata, handles)

handles.SiteIndexPre = handles.SiteIndexNow;
handles.SiteIndexNow = handles.SiteIndexNow + 1;

if handles.SiteIndexNow <= length(handles.UniqueSite),
   [hObject, eventdata, handles] = Update_SiteRelated(hObject, eventdata, handles);
else
   handles.SiteIndexNow = handles.SiteIndexNow - 1;
%   set(handles.edit2,'String','Reach End');         
end

guidata(hObject,handles);

%% [Push] Previous Site
function pushbutton3_Callback(hObject, eventdata, handles)

handles.SiteIndexPre = handles.SiteIndexNow;
handles.SiteIndexNow = handles.SiteIndexNow - 1;

if handles.SiteIndexNow >= 1,
   [hObject, eventdata, handles] = Update_SiteRelated(hObject, eventdata, handles);
else
   handles.SiteIndexNow = handles.SiteIndexNow + 1;
end

guidata(hObject,handles);

%% [Push] Last Site
function pushbutton8_Callback(hObject, eventdata, handles)

handles.SiteIndexPre = handles.SiteIndexNow;
handles.SiteIndexNow = handles.UniqueSite(end);
[hObject, eventdata, handles] = Update_SiteRelated(hObject, eventdata, handles);

guidata(hObject,handles);

%% [Push] Jump to Site
function pushbutton4_Callback(hObject, eventdata, handles, sitenum)

handles.SiteIndexPre = handles.SiteIndexNow;
handles.SiteIndexNow = sitenum;

[hObject, eventdata, handles] =...
    Update_SiteRelated(hObject, eventdata, handles);

guidata(hObject,handles);


%% [Function] Update_SiteRelated
function [hObject, eventdata, handles] = Update_SiteRelated(hObject, eventdata, handles)

handles.CurrentIndexes   = find(handles.SiteIndex == handles.SiteIndexNow); 

title = handles.SiteName(handles.SiteIndexNow,:);
if length(title) > 100, 
    title = title(1:100);
end

sample = handles.SampleName(handles.CurrentIndexes);
set(handles.text2,'String',title);
set(handles.text5,'String',char(sample));

if (length(handles.CurrentIndexes) >= 3) && (strcmp(get(handles.Plotmean,'Checked'),'on'))
    [hObject, eventdata, handles] =...
        pushbutton11_Callback(hObject, eventdata, handles);
else
    handles.meanon = 0; 
    handles.fstats = [];
    set(handles.text3, 'Visible','off');
end

Update_eaplot(hObject, eventdata, handles);


%% [function] Update_Equal Area Plot
function Update_eaplot(hObject, eventdata, handles)

if strcmp(get(handles.Drawa95,'Checked'),'on'), 
     handles.a95on = 1;
else
     handles.a95on = 0;
end
    
axes(handles.axes3), 
equalareaplot(handles.decl(handles.CurrentIndexes),...
                handles.incl(handles.CurrentIndexes),...
                  handles.a95(handles.CurrentIndexes),...
                    handles.East(handles.CurrentIndexes),...
                      handles.North(handles.CurrentIndexes),...
                         handles.Vertical(handles.CurrentIndexes),...
                           handles.fstats,...
                             handles.a95on,...
                               handles.meanon);    
                         
guidata(hObject,handles);


%% [Push] Update fisher_related
function [hObject, eventdata, handles] = pushbutton11_Callback(hObject, eventdata, handles)

handles.meanon = 1;

[hObject, eventdata, handles] = Update_fisher(hObject, eventdata, handles);
Update_Fisherboxes(hObject, eventdata, handles);

guidata(hObject,handles);


%% [Function] Update_fisher
function [hObject, eventdata, handles] = Update_fisher(hObject, eventdata, handles)

handles.fstats = fisher( handles.East(handles.CurrentIndexes),...
                  handles.North(handles.CurrentIndexes),...
                  handles.Vertical(handles.CurrentIndexes));
handles.fstats(6) = length(handles.East(handles.CurrentIndexes));

            
%% [Function] Update_Fisherboxes
function Update_Fisherboxes(hObject, eventdata, handles)

set(handles.text3, 'Visible','on');

formatspec = '%6.1f';
fdec    = ['Dm  = ', num2str(handles.fstats(1),formatspec)];
finc    = ['Im  = ', num2str(handles.fstats(2),formatspec)];
fa95    = ['a95 = ', num2str(handles.fstats(3),formatspec)];
fk      = ['k   = ', num2str(handles.fstats(4),formatspec)];
fR      = ['R   = ', num2str(handles.fstats(5),formatspec)];
fnums   = ['N   = ', num2str(handles.fstats(6),'%6d')];
 
set(handles.text3,'String',...
         char(fdec, finc, fa95, fk, fR, fnums));    


%% [Push] Fisher stats export
function pushbutton12_Callback(hObject, eventdata, handles)

if ~isempty(handles.fstats)
    % spaces are deleted
    remain = strtrim(handles.SiteName(handles.SiteIndexNow,:));
    sitename = [];
    while true
       [str, remain] = strtok(remain);
       sitename = [sitename, str];
       if isempty(str),  break;  end
    end
    if length(sitename) > 20 
        sitename = sitename(1:20);
    end

    filePathName = [handles.PathName, handles.fnamecore, 'fs.txt'];

    if fopen(filePathName)==-1,
       fid = fopen(filePathName,'at');
       fprintf(fid,...
         '!Site                 Dm     Im      a95     k      R      N\n');
       fprintf(fid, '%-20s\n', handles.fnamecore);
       fclose(fid);
       msgbox(['File: ', handles.fnamecore, 'fs.txt''',...
           ' has been created to save Fisher stats for ''',...
           handles.SiteName(handles.SiteIndexNow,:),''''],...
               'Fisher stats export confirmation','help');
    end

    fid = fopen(filePathName, 'at'); % 'a' here means append, 't' means text mode
    fprintf(fid, ['%-20s %6.1f %6.1f  %5.1f %6.1f %6.1f %4d \n'],...
                sitename, handles.fstats');
    fclose(fid);

    set(handles.edit7, 'Visible','on');
    set(handles.edit7,'String',['Fisher stats added for ',...
         handles.SiteName(handles.SiteIndexNow,:)]);
    pause(2);
    set(handles.edit7, 'Visible','off');
end

 
%% [Push] SavePlot Figure(s)
function pushbutton6_Callback(hObject, eventdata, handles)

H = direc16_SavePlotOption_dlg;
uiwait(H);

savePlotOption = getappdata(0, 'savePlotOptionUDIR');
rmappdata(0, 'savePlotOptionUDIR');

% spaces are deleted
remain = strtrim(handles.SiteName(handles.SiteIndexNow,:));
sitename = [];
while true
   [str, remain] = strtok(remain);
   sitename = [sitename, str];
   if isempty(str),  break;  end
end

switch savePlotOption
    case 1
         plotstring = [sitename,'dp'];
         h  = handles.figure1;
         xlimit = get(handles.figure1,'xlim');
         ylimit = get(handles.figure1,'ylim');        
    case 2    
         plotstring = [sitename,'ea'];
         h  = findobj(handles.axes3,'type','axes');   
         xlimit = get(handles.axes3,'xlim');
         ylimit = get(handles.axes3,'ylim');                  
    otherwise    % cancelled, no data for saving
         return;     
end

[filename, pathname, FilterIndex] =...
uiputfile({'*.pdf','Portable Document Format (*.pdf)';
            '*.eps','EPS Level2 (*.eps)';
            '*.png','Portable Network Graphics (*.png)';
            '*.jpg','JPEG image (*.jpg)';
            '*.tif','TIFF image (*.tif)';
            '*.bmp','Windows bitmap (*.bmp)';
            '*.fig','MATLAB figure (*.fig)'},...
            'Save selected plot as',...
            [handles.PathName, plotstring]);

if  ~isequal(filename,0), 
    if savePlotOption ==1
        orient landscape
        newFig = handles.figure1;
        if FilterIndex == 2,
           saveas(newFig,[pathname,filename], 'psc2');
        else   
           saveas(newFig,[pathname,filename]);
        end
    else
        newFig = figure('Units', 'default', 'Position', 'default');
        newAxes = copyobj(h,newFig); 
        set(newAxes,'Units','default','Position','default');
        set(newAxes, 'xlim', xlimit);
        set(newAxes, 'ylim', ylimit);
        if FilterIndex == 2,
           saveas(newFig,[pathname,filename], 'psc2');
        else   
           saveas(newFig,[pathname,filename]);
        end
        close(newFig);
    end    

end


%% [Function] Equal Area Plot
function equalareaplot(decl, incl, a95, east, north, vertical,...
                         fstats, a95on, meanon)
                     
t=linspace(0,2*pi,10000);
xx = 90*cos(t);
yy = 90*sin(t);

% ---------add white background

area(xx, yy, 'facecolor', 'none', 'edgecolor', 'none',...
    'ShowBaseLine', 'off'); hold on;
   
% ---------draw a circle
plot(xx,yy,'k','LineWidth',2);
axis equal;
axis off;


% ---------Add incl ticks
inclstick = (10:10:80)';
plot(              0,               0,'k+','markersize',42,'MarkerFaceColor','k');

% ---------Add Decl tick
xdata = [90*sind(  0), 84*sind(  0), NaN, ...
         90*sind( 90), 84*sind( 90), NaN, ...
         90*sind(180), 84*sind(180), NaN, ...
         90*sind(270), 84*sind(270), NaN];   
ydata = [90*cosd(  0), 84*cosd(  0), NaN, ...
         90*cosd( 90), 84*cosd( 90), NaN, ...
         90*cosd(180), 84*cosd(180), NaN, ...
         90*cosd(270), 84*cosd(270), NaN];         
line('xdata', xdata, 'ydata', ydata);

% ----------Add label
text(0  ,  90, 'N'  , 'verticalalignment', 'bottom', 'horizontalalignment', 'center');

% ----------Add data
% if ispc   
%    snms = 5;   snmms = 7;
% else
%    snms = 6;   snmms = 8;
% end
   snms = 6;   snmms = 8;
% plotting points
indexp = find(incl>=0);
indexn = find(incl<0);
declp = decl(indexp);
decln = decl(indexn);
inclp = incl(indexp);
incln = incl(indexn);

xcp = (90-inclp).*sind(declp);
ycp = (90-inclp).*cosd(declp);
xcn = -(90+incln).*sind(180+decln);
ycn = -(90+incln).*cosd(180+decln);
plot(xcp, ycp, 'bo', 'MarkerFaceColor','b','markersize',snms);  hold on;
plot(xcn, ycn, 'ro', 'MarkerFaceColor','none','markersize',snms);  hold on;

%drawing a95 circles
if a95on    
    mvec = [north, east, vertical];   
    for ii=1:size(mvec,1)
       if a95(ii) > 1.0 
         smallcircle(mvec(ii,:), a95(ii));
       end  
    end
end

% site-mean
if meanon
    if fstats(2) >= 0
        xcp = (90-fstats(2)).*sind(fstats(1));
        ycp = (90-fstats(2)).*cosd(fstats(1));
        plot(xcp, ycp, 'bs', 'MarkerFaceColor','b','markersize',snmms);  hold on;      
    else
        xcn = -(90+fstats(2)).*sind(180+fstats(1));
        ycn = -(90+fstats(2)).*cosd(180+fstats(1));
        plot(xcn, ycn, 'rs', 'MarkerFaceColor','none','markersize',snmms);  hold on;
    end
    
    meand = [cosd(fstats(1))*cosd(fstats(2)),...
               sind(fstats(1))*cosd(fstats(2)), sind(fstats(2))];
           
    if fstats(3) > 0  
        a95tmp = fstats(3);
    else
        a95tmp = 0.1;
    end    
    smallcircle(meand, a95tmp);
end        

hold off;

%% [Function] Small cicrle 
function smallcircle(dvec, a95)

    ra95 = a95/180.0*pi;
    angstep = 2.0/180.0*pi;
    zaxis = [0 0 1];

    aang = angstep; scz = [];
    while aang < 2*pi
    scz = [scz, rotmat([cos(aang) sin(aang) 0], ra95, zaxis')];              
    aang = aang + angstep;
    end
    scz = [scz, scz(:,1)];

    angdis = acos(dot(zaxis, dvec/(norm(zaxis)*norm(dvec))));
    g = cross(zaxis, dvec);
    g = g/norm(g);

    scp = rotmat(g, angdis, scz);

    dec = atan2d(scp(2,:), scp(1,:));
    if (dec <= 0) dec = dec + 360.0;  end  
    inc = asind(scp(3,:));

    jj = 1; 
    while (jj <= length(dec))
        xlp=[]; ylp=[]; xln=[]; yln=[];
        while (inc(jj) >= 0)
        xlp = [xlp (90-inc(jj))*sind(dec(jj))];
        ylp = [ylp (90-inc(jj))*cosd(dec(jj))];
        jj = jj+1; 
        if jj > length(dec), break; end
        end
        if (jj <= length(dec))
         while (inc(jj) < 0)
            xln = [xln -(90+inc(jj))*sind(180+dec(jj))];
            yln = [yln -(90+inc(jj))*cosd(180+dec(jj))];
            jj = jj+1; 
            if jj > length(dec), break; end
         end
        end    
        plot(xlp, ylp, 'b-'); 
        plot(xln, yln, 'r--');       
    end
        
%% [Function] Rotation Matrix        
function rvec = rotmat(dircos, rang, vec)

    l = dircos(1); m = dircos(2); n = dircos(3);
    
     rmat = [l^2 + (1.0 - l^2)*cos(rang)  ...
               l*m*(1.0 - cos(rang)) - n*sin(rang)  ...
                  l*n*(1.0 - cos(rang)) + m*sin(rang);...
            l*m*(1.0-cos(rang)) + n*sin(rang)  ...
               m^2 + (1 - m^2)*cos(rang)  ...
                  m*n*(1.0-cos(rang))-l*sin(rang);...
            l*n*(1.0 - cos(rang)) - m*sin(rang)  ...
               m*n*(1.0 - cos(rang)) + l*sin(rang)  ...
                  n^2 + (1.0 - n^2)*cos(rang)];
    rvec = rmat*vec;              


%% [Function] Fstats
function fstats = fisher(east, north, vertical)
    
    data = [north, east, vertical];
    [nump, vec3] = size(data);
    R = norm(sum(data));
    dircos = sum(data)/R;
    decm = atan2d(dircos(2), dircos(1));
    if (decm <= 0) decm = decm + 360.0;  end  
    incm = asind(dircos(3));
    
    if R/nump >= 0.9
        kk = (nump - 1.0)/(nump - R);
    else
        kk = NaN;
    end  

    if kk >= 5.0
      a95 = acosd(1.0 - (nump - R)/R*((1.0/0.05)^(1/(nump -1.0)) -1.0));
    else
      a95 = NaN;  % make a95 radius sufficeintly small
    end
    
    fstats = [decm, incm, a95, kk, R];
    

%% [edit]
% --- Executes during object creation, after setting all properties.
function text3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: move controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end

% --- Executes during object creation, after setting all properties.
function text5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: move controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%     set(hObject,'BackgroundColor','white');
% end

function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double

function edit7_Callback(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit7 as text
%        str2double(get(hObject,'String')) returns contents of edit7 as a double

% --- Executes during object creation, after setting all properties.
function edit7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%% [Menu]
% --------------------------------------------------------------------
function File_Callback(hObject, eventdata, handles)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Open_Callback(hObject, eventdata, handles)
   pushbutton1_Callback(hObject, eventdata, handles);
% hObject    handle to Open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function OpenRecent_Callback(hObject, eventdata, handles)
% hObject    handle to OpenRecent (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function Close_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)

% --------------------------------------------------------------------
function CopyFigure_Callback(hObject, eventdata, handles)
    orient landscape
    if ispc
       print(handles.figure1,'-clipboard','-dmeta');     %for win
    else
       print(handles.figure1,'-clipboard','-dpdf');     %for mac
    end
    set(handles.edit7, 'Visible','on');
    set(handles.edit7,'String',['Copy to Clipboard: ',...
         handles.SiteName(handles.SiteIndexNow,:)]);
    pause(2);
    set(handles.edit7, 'Visible','off');

% hObject    handle to CopyFigure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function SavePlot_Callback(hObject, eventdata, handles)
   pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to SavePlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Move_Callback(hObject, eventdata, handles)
% hObject    handle to Move (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Top_Callback(hObject, eventdata, handles)
   pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to Top (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Forward_Callback(hObject, eventdata, handles)
   pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to Forward (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Backward_Callback(hObject, eventdata, handles)
   pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to Backward (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Last_Callback(hObject, eventdata, handles)
   pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to Last (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Jumpto_Callback(hObject, eventdata, handles)
% hObject    handle to Jumptom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Site_Callback(hObject, eventdata, handles)
% hObject    handle to PCA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Drawa95_Callback(hObject, eventdata, handles)

    if strcmp(get(handles.Drawa95,'Checked'),'on'), 
         set(handles.Drawa95,'Checked','off'); 
    else
         set(handles.Drawa95,'Checked','on'); 
    end

    Update_eaplot(hObject, eventdata, handles);
% hObject    handle to Drawa95 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function Plotmean_Callback(hObject, eventdata, handles)

    if strcmp(get(handles.Plotmean,'Checked'),'on'), 
         set(handles.Plotmean,'Checked','off'); 
    else
         set(handles.Plotmean,'Checked','on'); 
    end
    
    Update_SiteRelated(hObject, eventdata, handles);
% hObject    handle to pcapanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function ExportFstats_Callback(hObject, eventdata, handles)
   pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to ExportFstats (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%% [Push] Save pdf
function Exportpdf_Callback(hObject, eventdata, handles)

    % spaces are deleted
    remain = strtrim(handles.SiteName(handles.SiteIndexNow,:));
    sitename = [];
    while true
       [str, remain] = strtok(remain);
       sitename = [sitename, str];
       if isempty(str),  break;  end
    end
    
    plotstring = [sitename,'dp'];
    h  = handles.figure1;
    xlimit = get(handles.figure1,'xlim');
    ylimit = get(handles.figure1,'ylim');        

    [filename, pathname, FilterIndex] =...
    uiputfile([handles.PathName, plotstring, '.pdf']);

    if  ~isequal(filename,0), 
        newFig = handles.figure1;
        saveas(newFig,[pathname,filename]);
    end
